package org.ninjasoft.rovr.map;

import org.ninjasoft.rovr.net.MovementListener;
import java.util.Vector;
import java.util.Iterator;

public class Mapper implements MovementListener {
	public char grid[][];
	public int posx;
	public int posy;
	public int minx, miny, maxx, maxy;
	public int direction;
	private Vector listeners = new Vector();
	
	public Mapper() {
		reset();
	}
	
	public void reset() {
		this.grid = new char[500][500];
		this.posx = 250;
		this.posy = 250;
		this.minx = this.miny = this.maxx = this.maxy = 250;
		this.direction = 2;
		notifyListeners();
	}
	
	private void calcMax(int x, int y) {
		minx = Math.min(minx, x);
		maxx = Math.max(maxx, x);
		miny = Math.min(miny, y);
		maxy = Math.max(maxy, y);
	}
	
	private void moveset(int direction, char wall) {
		int newx = this.posx;
		int newy = this.posy;
		switch(direction) {
		case 8:
			newy--;
			break;
		case 2:
			newy++;
			break;
		case 4:
			newx--;
			break;
		case 6:
			newx++;
			break;
		}
		System.out.println("Setting (" + newx + "," + newy + ") to " + (int) wall);
		grid[newx][newy] = wall;
		calcMax(newx, newy);
		if (wall == 2) {
			posx = newx;
			posy = newy;
		}
		notifyListeners();
	}
	
	public void addMapChangeListener(MapChangeListener listener) {
		this.listeners.add(listener);
	}
	
	public void removeMapChangeListener(MapChangeListener listener) {
		this.listeners.remove(listener);
	}
	
	private void notifyListeners() {
		for (Iterator i = this.listeners.iterator(); i.hasNext(); )
			((MapChangeListener) i.next()).mapChanged();
	}
	
	public void movementResponse(int responseCode) {
		switch (responseCode) {
		case 20:
			moveset(this.direction, (char) 2);
			break;
		case 30:
		case 40:
			moveset(this.direction, (char) 1);
			break;
		}
	}

}
